;YAP!

AppTitle "YAP!"
Include "fontlib/bmpfont.bb"  

SeedRnd MilliSecs()

Global gamerunning = False

Global ball

Global playerscore = 0
Global enemyscore = 0

Global ballxspeed#
Global ballzspeed#

Global paddlexpos = -20
Global enemyxpos = 20

Global enemyzspeed# = 0.3
Global paddlezspeed# = 0.3

Global paddlelength = 8
Global paddlewidth = 2
Global paddleheight = 2

Graphics3D 800,600
SetBuffer BackBuffer()

;Load Media
Global yap=LoadImage("img/yap.bmp")
MidHandle yap
Global yap1=LoadImage("img/yap1.bmp")
MidHandle yap1
Global enter=LoadImage("img/enter.bmp")
MidHandle enter
Global scores=LoadImage("img/scores.bmp")
MidHandle scores
Global win=LoadImage("img/win.bmp")
MidHandle win
Global lose=LoadImage("img/lose.bmp")
MidHandle lose
Global kungfista=LoadImage("img/kungfista.bmp")
MidHandle kungfista

bluefont = LoadBMPFont("bluefont")
redfont = loadBMPFont("redfont")

ballsound = LoadSound ("snd/ball.wav")
bordersound = LoadSound("snd/border.wav")

;Camera & Lights
camerapivot = CreatePivot()

camera=CreateCamera(camerapivot)
RotateEntity camera,45,0,0
PositionEntity camera,0,30,-30

light1=CreateLight(1)
RotateEntity light1,45,0,0

light2=CreateLight(1)
RotateEntity light2,135,0,0

AmbientLight 50,50,50

Global moved = True

Global collided

Global delaytimer 

;Ball
Function MakeBall()
	ball=LoadMesh("msh/soccerball.x")
	ScaleEntity ball,0.3,0.3,0.3,True
	PositionEntity ball,0,0.8,0
	EntityType ball,1
	ballxspeed = 0
	ballzspeed = 0
	delaytimer=MilliSecs()
	moved = False
End Function

Function MoveBall()
	If MilliSecs()-delaytimer > 1500 And moved = False
		moved = True
		ballxspeed = 0.25 : collided = 1
		ballzspeed = 0.25
		ass=Rnd(1,2)
		If ass=2 
			ballxspeed = -ballxspeed
			collided = 2
		EndIf
		ass=Rnd(1,2)
		If ass=2 ballzspeed = -ballzspeed
	EndIf
End Function 
	
MakeBall() 

;Field
feld=LoadMesh("map/soccer.b3d")
EntityType feld,type_scenery
PositionEntity feld,0,0,0
ScaleEntity feld,4,4,4
EntityType feld,4

;Paddle
paddle=CreateCube()
EntityRadius paddle,paddlelength/2
PositionEntity paddle,paddlexpos,paddleheight/2,0
EntityColor paddle,0,0,123
ScaleEntity paddle,1,1,paddlelength/2
EntityType paddle,2

paddlelight=CreateLight(2,paddle)
LightRange paddlelight,5
LightColor paddlelight,0,0,255
PositionEntity paddlelight,0,0,0

;Enemy
enemy=CreateCube()
EntityRadius enemy,paddlelength/2
PositionEntity enemy,enemyxpos,paddleheight/2,0
EntityColor enemy,123,0,0
ScaleEntity enemy,1,1,paddlelength/2
EntityType enemy,3

enemylight=CreateLight(2,enemy)
LightRange enemylight,5
LightColor enemylight,255,0,0
PositionEntity enemylight,0,0,0


frametimer=CreateTimer(90)
entertimer=MilliSecs()
frontview = False

Global whack#

;Collisions
Collisions 1,2,2,2
Collisions 1,3,2,2
Collisions 1,4,2,2
Collisions 2,4,2,2
Collisions 3,4,2,2

Repeat

	If gamerunning = False 
		TurnEntity camerapivot,0,0.2,0
	EndIf
	
	;If Enter is pressed
	If KeyHit(28) And gamerunning = False
		gamerunning = True
		playerscore = 0 : enemyscore = 0
		FreeEntity ball
		PositionEntity paddle,paddlexpos,paddleheight/2,0
		PositionEntity enemy,enemyxpos,paddleheight/2,0
		MakeBall()
		RotateEntity camerapivot,0,0,0,True
	EndIf
	
	;If Esc is pressed
	If KeyHit(1)
		If gamerunning = True
			PositionEntity camera,0,30,-30
			RotateEntity camera,45,0,0
			frontview = False
			gamerunning = False
			
		Else
			End 
		EndIf
	EndIf 
	
	z#=0
	ez#=0
	
	;Enemy Control
	enemysight=Rnd(-5,5)
	If EntityX(ball) > enemysight
		If EntityZ(ball) > EntityZ(enemy) ez#=enemyzspeed
		If EntityZ(ball) < EntityZ(enemy) ez#=-enemyzspeed
	EndIf
	
	;Paddle Control 
	If gamerunning = True
		If frontview = False
			If KeyDown(208)=True Then z#=-paddlezspeed
			If KeyDown(200)=True Then z#=paddlezspeed
		Else
			If KeyDown(205)=True Then z#=-paddlezspeed
			If KeyDown(203)=True Then z#=paddlezspeed
		EndIf
	Else
		enemysight=Rnd(-5,5)
		If EntityX(ball) < enemysight
			If EntityZ(ball) > EntityZ(paddle) z#=paddlezspeed
			If EntityZ(ball) < EntityZ(paddle) z#=-paddlezspeed
		EndIf
	EndIf

	;Ball Control
	MoveBall()
	
	;Collision with Paddle or Enemy
	If gamerunning = True
		If collided = 2
			If EntityCollided(ball,2) 
				collided = 1
				PlaySound (ballsound)
				ballxspeed = -ballxspeed+0.02
				ballzspeed = -(EntityZ(paddle) - CollisionZ(ball,1))/4*ballxspeed
				If ballzspeed = 0 
					Repeat
						ballzspeed = Rand(-1,1)/10
					Until ballzspeed <> 0
				EndIf
			EndIf
		EndIf
	Else
		If collided = 2  
			If EntityCollided (ball,2)
				collided = 1
				PlaySound (ballsound)
					ballxspeed = -ballxspeed+0.02
					Repeat	
						whack = Rand(-4,4)
					Until whack <> 0 
					ballzspeed = whack/4*ballxspeed
				EndIf
			EndIf
		EndIf
				
	If collided = 1
		If EntityCollided (ball,3) 
			collided = 2
			PlaySound (ballsound)
			ballxspeed = -ballxspeed-0.02
				Repeat
					whack = Rand(-4,4)
				Until whack <> 0 
			ballzspeed = whack/4*ballxspeed
		EndIf
	EndIf
		
	;Collision with Border
	If EntityCollided (ball,4) 
		PlaySound(bordersound)
		ballzspeed = -ballzspeed
	EndIf

	;Movements
	MoveEntity paddle,x#,y#,z#
	MoveEntity enemy,ex#,ey#,ez#
	TranslateEntity ball,ballxspeed#,ballyspeed#,ballzspeed#
	TurnEntity ball,ballzspeed#*50,0,-ballxspeed#*50,True
	
	;Goal Shot? Add score & make new ball!
	If EntityX(ball) < -21 Or EntityX(ball) > 21
		If EntityX(ball) < -21 enemyscore = enemyscore + 1
		If EntityX(ball) > 21 playerscore = playerscore + 1
		FreeEntity ball
		PositionEntity enemy,enemyxpos,paddleheight/2,0
		MakeBall()
	EndIf
	
	WaitTimer(frametimer)
	
	UpdateWorld
	
	RenderWorld
	
	If gamerunning = True	
		
		DrawImage scores,GraphicsWidth()/2,20
		
		BMPText bluefont,GraphicsWidth()/3,30,playerscore,True,True
		BMPText redfont,2*GraphicsWidth()/3,30,enemyscore,True,True

		If playerscore = 10
			If MilliSecs() - entertimer > 2000 entertimer = MilliSecs()
			If MilliSecs() - entertimer > 1000 BMPText bluefont,GraphicsWidth()/2,GraphicsHeight()/2,"YOU WIN! ^_^",True,True
			FreeEntity ball
			PositionEntity enemy,enemyxpos,paddleheight/2,0
			MakeBall()
			ballxspeed = 0
			ballyspeed = 0
		EndIf
		
		If enemyscore = 10
			If MilliSecs() - entertimer > 2000 entertimer = MilliSecs()
			If MilliSecs() - entertimer > 1000 BMPText redfont,GraphicsWidth()/2,GraphicsHeight()/2,"YOU LOSE! :(",True,True
			FreeEntity ball
			PositionEntity enemy,enemyxpos,paddleheight/2,0
			MakeBall()
			ballxspeed = 0
			ballyspeed = 0
		EndIf

		;Topview
		If KeyHit(20)
			frontview = False
			PositionEntity camera,0,30,0
			RotateEntity camera,90,0,0
		EndIf
		
		;Sideview
		If KeyHit(31)
			frontview = False
			PositionEntity camera,0,30,-30
			RotateEntity camera,45,0,0
		EndIf
		
		;Frontview
		If KeyHit(33)
			frontview = True
			PositionEntity camera,-32,27,0
			RotateEntity camera,45,-90,0
		EndIf			

	Else
		DrawImage yap,GraphicsWidth()/2,50
		DrawImage yap1,GraphicsWidth()/2,120
		DrawImage kungfista,GraphicsWidth()/2,GraphicsHeight()-15

		
		If MilliSecs() - entertimer > 1000 DrawImage enter,GraphicsWidth()/2,GraphicsHeight()/2
		If MilliSecs() - entertimer > 2000 entertimer = MilliSecs()
	EndIf

	Flip

Forever

End